'' PropCOMM Ethernet Edition w/PETSCII COLOR EMULATION 
'' By Jeff Ledger
'' SEE CON for I/O Settings & Text Color Configuration!

DAT
  ip_addr       byte    192, 168, 108, 200 ' device's ip address
  ip_subnet     byte    255, 255, 255, 0   ' network subnet
  ip_gateway    byte    192, 168, 108, 1   ' network gateway (router)
  ip_dns        byte    192, 168, 108, 1   ' network dns
  
CON

   _clkmode  = xtal1 + pll16x
   _xinfreq  = 5_000_000
   
  '' I/O SETTINGS
  '' Adjust for typical location of the keyboard. Usually 26 on the demoboard
  
   keyboard  = 26
   video     = 12

  
  '' LOCATION OF ETHERNET CHIP

            'Spin Socket A      'Spin Socket D
   cs        = 3                '19
   sck       = 4                '20
   si        = 5                '21
   so        = 6                '22
   int       = 7                '23

   
  '' Remote Systems BBS Listings

  '' Temporal Vortex BBS
  adial1        = 24
  adial2        = 239
  adial3        = 254
  adial4        = 21
  aport         = 6400
  
  
  '' Color Assignments for video driver
  
  BLACK             = $02 
  GREY              = $03
  LWHITE            = $06
  BWHITE            = $07
  LMAGENTA          = $A3 
  WHITE             = $AF
  RED               = $A2
  LRED              = $1A
  LPURPLE           = $1B
  PURPLE            = $03 
  LGREEN            = $1C
  SKYBLUE           = $1D
  YELLOW            = $1E
  BYELLOW           = $A6
  LGREY             = $1F
  DGREY             = $08
  GREEN             = $A4
  ORANGE            = $06
  BLUE              = $A1 
  CYAN              = $1C
  MAGENTA           = $FC
  LYELLOW           = $1E

  textcolor         = $AF
  


  '' Key Assignments 

  fReturn   = 13
  bspKey    = $C8
  escape    = $CB
  backspace = 8

  CR                            = $0D
  LF                            = $0A
  TAB                           = $09
  BKS                           = $08


   
OBJ
     key   : "comboKeyboard"   
     text  : "aigeneric_driver"
     ser   : "api_telnet_serial"
        
VAR
     byte command[32]
     byte f0[32]
     byte tbuf[20] ' SD Vars
     long ioControl[2] 
     long tp
     byte cline[42]
     byte ext[3]
     byte strbuff[5]

PUB mainProgram  | local,remote,duplex,petscii,r,port,system

  key.start(keyboard)
  text.start(video)
  ser.start(cs, sck, si, so, int,-1,-1,@ip_addr)
  petscii := 1   ' SET PETSCII TERMINAL TO BE ON AT BOOT
  system := 1
  
' repeat
  text.cls
  displaymenu
  text.str(string("EMULATION MODE: "))
  if petscii == 1
     text.str(string("PETSCII",CR,CR))
  if system == 1
     text.str(string("CONNECT TO: TEMPORAL VORTEX BBS"))
     
  repeat
   local := key.getkey
   if local <> 0
     if local == 208     'DIAL
       system++
         if system == 4 'Loop conneciton counter
           system := 1
         text.cls
         displaymenu
         text.str(string("EMULATION MODE: "))
         if petscii == 1
           text.str(string("PETSCII",CR,CR))
         if petscii == 0
           text.str(string("ASCII/COLOR",CR,CR))

         if system == 1
           text.str(string("CONNECT TO: TEMPORAL VORTEX BBS"))
         if system == 2
           text.str(string("CONNECT TO: JAMMINGSIGNAL BBS"))
         if system == 3
           text.str(string("CONNECT TO: COTTONWOOD I BBS"))
                                                                                


     if local == 209     'SELECT MODE PETSCII
       petscii := 1
         text.cls
         displaymenu
         text.str(string("EMULATION MODE: "))
         if petscii == 1
           text.str(string("PETSCII",CR,CR))
         if petscii == 0
           text.str(string("ASCII/COLOR",CR,CR))

         if system == 1
           text.str(string("CONNECT TO: TEMPORAL VORTEX BBS"))
         if system == 2
           text.str(string("CONNECT TO: JAMMINGSIGNAL BBS"))
         if system == 3
           text.str(string("CONNECT TO: COTTONWOOD I BBS"))


       
     if local == 210
       petscii := 0      'SELECT MODE ASCII/COLOR
         text.cls
         displaymenu
         text.str(string("EMULATION MODE: "))
         if petscii == 1
           text.str(string("PETSCII",CR,CR))
         if petscii == 0
           text.str(string("ASCII/COLOR",CR,CR))
         if system == 1
           text.str(string("CONNECT TO: TEMPORAL VORTEX BBS"))
         if system == 2
           text.str(string("CONNECT TO: JAMMINGSIGNAL BBS"))
         if system == 3
           text.str(string("CONNECT TO: COTTONWOOD I BBS"))
     
     if local == 211     'SELECT TERMINAL MODE
            
       repeat
        text.cls 
        text.str(string(CR,CR,"ATTEMPTING CONNECTION: "))

        delay_ms(1000)

        port := 20000
 
  
        if port > 30000
           port := 20000

        ++port
        if system == 1
          ser.connect(24,239,254,21,6400,port) ' Temporal Vortex BBS
        if system == 2
          ser.connect(209,151,141,59,23,port) ' Jamming Signal
        if system == 3
          ser.connect(71,165,231,216,23,port) ' Cottonwood I



        ser.resetBuffers
    
        ser.waitConnectTimeout(2000)
     
        if ser.isConnected 
          text.str(string("CONNECTED",CR))
          duplex := 0
          repeat
             local := key.key
             if local <> 0
                if duplex == 1 
                   text.out(local)
                  'text.dec(local) 'Used to troubleshoot local input
            
                if petscii == 1 and local > 96 and local < 128
                  local := local -=32
                elseif petscii == 1 and local >64 and local < 91
                  local := local +=32
            
                ser.tx(local)
                if local == fReturn
                  'ser.tx(10) ' may not be needed for standard BBS use
                  'ser.tx(13) ' may not be needed for standard BBS use
                if local == bspKey
                  ser.str(string(8," ",8,8))
        
             remote := ser.rxtime(50)
             if remote == 8
                text.str(string(backspace," ",backspace))
                remote := 0
   
       '' PETSCII COLOR EMULATION
             if petscii == 1
               if remote == 5
                 text.color(textcolor)
                 remote :=0
               if remote == 28
                 text.color(red)
                 remote :=0 
               if remote == 30
                 text.color(green)
                 remote :=0 
               if remote == 31
                 text.color(blue)
                 remote :=0 
               if remote == 156
                 text.color(purple)
                 remote :=0 
               if remote == 158
                 text.color(yellow)
                 remote :=0 
               if remote == 159
                 text.color(cyan)
                 remote :=0 
               if remote == 150
                 text.color(lred)
                 remote :=0 
               if remote == 151
                 text.color(lgrey)
                 remote :=0 
               if remote == 152
                 text.color(dgrey)
                 remote :=0 
               if remote == 129
                 text.color(orange)
                 remote :=0 
               if remote == 153
                 text.color(lgreen)
                 remote :=0 
               if remote == 154
                 text.color(skyblue)
                 remote :=0
               if remote == 144
                 text.color(black)
                 remote :=0
               if remote == 149
                 text.color(lyellow)  'should be brown
                 remote :=0

               if remote == 18 or remote == 146  'Remove REV/REFOFF Control Characters
                 remote :=0

               if remote == 147 ' PETSCII CLEAR SCREEN
                 text.cls
                 remote :=0
           
               if remote == 148 or remote == 20
                 text.str(string(backspace," ",backspace))
                 remote :=0 
               if remote == 157
                 text.str(string(backspace," ",backspace))
                 remote :=0 
               if remote == 8
                 text.str(string(backspace," ",backspace))
                 remote := 0

               if remote > 96 and remote < 128          '' Switch upper/LOWER case
                  remote := remote-=32                  '' Petscii to display correctly.
               elseif remote > 64  and remote < 91      '' *:Petscii<>ASCII conversion:*
                  remote := remote+=32

               if remote > 10
               '  text.dec(remote) 'Used to troubleshoot remote input
                  text.out(remote)
                      
        else
            text.str(string("ERROR, RETRY",CR))
    
            ser.close
            delay_ms(100)             ' failed to connect, try again in 100ms
        
PRI delay_ms(Duration)
  waitcnt(((clkfreq / 1_000 * Duration - 3932)) + cnt)

PUB displaymenu
     text.out(13)
    text.out(13)
    text.color(skyblue)
    text.str(string("PropETH Terminal V2.0b By Jeff Ledger",CR))
    text.color(white)
    text.str(string("--------------------------------------",CR))
    text.out(13)
    text.str(string("["))
    text.color(skyblue)
    text.str(string("F1"))
    text.color(textcolor)
    text.str(string("] = SELECT DESTINATION",CR))
    text.str(string("["))
    text.color(skyblue)
    text.str(string("F2"))
    text.color(textcolor)
    text.str(string("] = TOGGLE PETSCII MODE",CR))
    text.str(string("["))
    text.color(skyblue)
    text.str(string("F3"))
    text.color(textcolor)
    text.str(string("] = TOGGLE ASCII/COLOR MODE",CR))
    text.str(string("["))
    text.color(skyblue)
    text.str(string("F4"))
    text.color(textcolor)
    text.str(string("] = CONNECT",CR,CR,CR))

  
     